.686
.model flat,stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include version.inc
includelib version.lib
include rsrc.inc
include verinf.inc

.data
szHfmt db "%.8X",0
szCrLf db 13,10,0
szTrans db '\VarFileInfo\Translation\',0
szStrInf db '\StringFileInfo\',0
szFileDesc db '\FileDescription\',0
szFileDescf db 'FileDescription: %s',0
szFileVer db '\FileVersion\',0
szFileVerf db 'FileVersion: %s',0
szLegCopy db '\LegalCopyright\',0
szLegCopyf db 'LegalCopyright: %s',0

.code

AddLine proc hOutEdt,szLine
	.if szLine
		invoke SendMessage,hOutEdt,EM_SETSEL,-1,TRUE
		invoke SendMessage,hOutEdt,EM_REPLACESEL,0,szLine
	.endif
	invoke SendMessage,hOutEdt,EM_SETSEL,-1,TRUE
	invoke SendMessage,hOutEdt,EM_REPLACESEL,0,addr szCrLf
	ret
AddLine endp

AddLinef proc c hOutEdt,pFormat,vargs:VARARG 
LOCAL pITextBuff
	invoke GlobalAlloc,GPTR,1000h
	mov pITextBuff,eax
	;;invoke wvnsprintf,pITextBuff,1000h,pFormat,addr vargs
	invoke wvsprintf,pITextBuff,pFormat,addr vargs
	invoke AddLine,hOutEdt,pITextBuff
	invoke GlobalFree,pITextBuff
	ret
AddLinef endp

GetInfo proc uses esi edi ebx hInst,hOutEdit 
LOCAL dwHandle,pBuf,pLen,szExePath[MAX_PATH]:byte,tbuf[100h]:byte,tbuf2[100h]:byte
	invoke GetModuleFileName,hInst,addr szExePath,MAX_PATH
	invoke GetFileVersionInfoSize,addr szExePath,addr dwHandle
	mov ebx,eax 
	.if eax
		invoke GlobalAlloc,GPTR,ebx
		mov edi,eax
		invoke GetFileVersionInfo,addr szExePath,dwHandle,ebx,edi
		mov pLen,ebx
		invoke VerQueryValue,edi,addr szTrans,addr pBuf,addr pLen
		invoke lstrcpy,addr tbuf,addr szStrInf
		invoke lstrlen,addr tbuf
		mov edx,pBuf
		lea eax,tbuf[eax]
		mov edx,[edx]
		rol edx,16
		invoke wsprintf,eax,addr szHfmt,edx
		;-
		invoke lstrcpy,addr tbuf2,addr tbuf
		invoke lstrcat,addr tbuf2,addr szFileDesc
		invoke VerQueryValue,edi,addr tbuf2,addr pBuf,addr pLen
		invoke AddLinef,hOutEdit,addr szFileDescf,pBuf
		;-
		invoke lstrcpy,addr tbuf2,addr tbuf
		invoke lstrcat,addr tbuf2,addr szFileVer
		invoke VerQueryValue,edi,addr tbuf2,addr pBuf,addr pLen
		invoke AddLinef,hOutEdit,addr szFileVerf,pBuf		
		;-
		invoke lstrcpy,addr tbuf2,addr tbuf
		invoke lstrcat,addr tbuf2,addr szLegCopy
		invoke VerQueryValue,edi,addr tbuf2,addr pBuf,addr pLen
		invoke AddLinef,hOutEdit,addr szLegCopyf,pBuf
		;-		
		invoke GlobalFree,edi
	.endif
	ret
GetInfo endp

DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	mov eax,uMsg
	.if eax==WM_INITDIALOG
		invoke GetDlgItem,hWnd,IDC_EDT1
		invoke GetInfo,lParam,eax
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWnd,0
	.else
		xor eax,eax
		ret
	.endif
	mov eax,TRUE
	ret
DlgProc endp

start:
	invoke GetModuleHandle,0
	invoke DialogBoxParam,eax,IDD_DIALOG1,0,offset DlgProc,eax
	invoke ExitProcess,eax
end start

